const io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

function parseURI()
{
	var uri;
	try
	{
		try
		{
			uri = io.newURI(document.getElementById("host").value, null, null);
		}
		catch(e)
		{
			uri = io.newURI("ftp://" + document.getElementById("host").value, null, null);
		}
		if (uri.scheme == "file")
		{
			document.getElementById("username").value = "";
			document.getElementById("password").value = "";
			document.getElementById("path").value = "";
		}
		else
		{
			if (uri.username != "") document.getElementById("username").value = decodeURI(uri.username);
			if (uri.password != "") document.getElementById("password").value = decodeURI(uri.password);
			if (uri.path != "" && uri.path != "/") document.getElementById("path").value = decodeURI(uri.path);
			if (uri.scheme == "ftp")
				document.getElementById("host").value = uri.hostPort;
			else
			{
				uri.userPass = "";
				document.getElementById("host").value = uri.prePath;
			}
		}
	}
	catch(e) {};
}

function init()
{
	if (window.opener)
	{
		window.sizeToContent();
		window.moveTo(window.opener.screenX+(window.opener.outerWidth-window.outerWidth)/2,window.opener.screenY+(window.opener.outerHeight-window.outerHeight)/2);
	}
	try { document.documentElement.setAttribute("title", window.arguments[0].title); } catch(e) {}
	try
	{
		var uri = window.arguments[0].uri;
		if (1) // donno how to check... do later
		{
			if (uri.scheme == "file")
			{
				document.getElementById("host").value = uri.spec;
			}
			else
			{
				if (uri.username != "") document.getElementById("username").value = decodeURI(uri.username);
				if (uri.password != "") document.getElementById("password").value = decodeURI(uri.password);
				if (uri.path != "" && uri.path != "/") document.getElementById("path").value = decodeURI(uri.path);
				if (uri.scheme == "ftp")
					document.getElementById("host").value = uri.hostPort;
				else
				{
					uri.userPass = "";
					document.getElementById("host").value = uri.prePath;
				}
			}
		}
	}
	catch(e) {}
}

function okay()
{
	var uri;
	try
	{
		try
		{
			uri = io.newURI(document.getElementById("host").value, null, null);
		}
		catch(e)
		{
			uri = io.newURI("ftp://" + document.getElementById("host").value, null, null);
		}
		if (uri.scheme != "file")
		{
			uri.username = document.getElementById("username").value;
			if (uri.username != "") uri.password = document.getElementById("password").value;
			uri.path = document.getElementById("path").value;
		}
	}
	catch(e) { return false; }

	try
	{
		window.arguments[0].uri = uri;
		window.arguments[0].value = true;
	}
	catch(e) {}
	return true;
}

function cancel()
{
	try
	{
		window.arguments[0].uri = null;
		window.arguments[0].value = false;
	}
	catch(e) {}
}